"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.between = void 0;
const types_1 = require("../types");
const map_1 = require("./map");
const seq_1 = require("./seq");
/** Parses a sequence of three parsers.
 * @returns A parser returning only the middle parser's result.
 */
function between(left, parser, right) {
    return (ctx) => {
        const res = map_1.map(seq_1.seq(left, parser, right), val => val[1])(ctx);
        if (types_1.isFailure(res)) {
            const newHistory = [...res.history];
            newHistory.splice(0, 2);
            return types_1.failure(res.ctx, res.expected, ['between', ...newHistory]);
        }
        return res;
    };
}
exports.between = between;
