"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.opt = void 0;
const types_1 = require("../types");
/** Makes the parser optional.
 * @returns A parser that succeeds with `null` result if the parsing didn't succeed.
 */
function opt(parser) {
    return (ctx) => {
        const parseResult = parser(ctx);
        if (types_1.isFailure(parseResult)) {
            return types_1.success(ctx, null);
        }
        return parseResult;
    };
}
exports.opt = opt;
