"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.regex = void 0;
const types_1 = require("../types");
/** Parses a regex and returns the matched result of the parse.
 * @returns A parser parsing a given regex and returning a match.
 */
function regex(match, expected) {
    return (ctx) => {
        const regexMatch = ctx.text.substr(ctx.index).match(match);
        if (regexMatch !== undefined && regexMatch !== null && regexMatch.index === 0) {
            return types_1.success({ ...ctx, index: ctx.index + regexMatch[0].length }, ctx.text.substr(ctx.index, regexMatch[0].length));
        }
        else {
            return types_1.failure(ctx, expected, [expected]);
        }
    };
}
exports.regex = regex;
