"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.seq = void 0;
const types_1 = require("../types");
function seq(...parsers) {
    return (ctx) => {
        const values = [];
        for (const parser of parsers) {
            const res = parser(ctx);
            ctx = res.ctx;
            if (types_1.isFailure(res))
                return types_1.failure(res.ctx, res.expected, ['seq', ...res.history]);
            values.push(res.value);
        }
        return types_1.success(ctx, values);
    };
}
exports.seq = seq;
