"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.str = void 0;
const types_1 = require("../types");
/** Parses a string and returns it as a result of the parse.
 * @returns A parser parsing a given string.
 */
function str(match) {
    return (ctx) => {
        if (ctx.text.substr(ctx.index, match.length) === match) {
            return types_1.success({ ...ctx, index: ctx.index + match.length }, match);
        }
        else {
            return types_1.failure(ctx, match, [match]);
        }
    };
}
exports.str = str;
