"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.realP = exports.real = exports.intP = exports.int = exports.boolP = exports.bool = exports.wspaces = exports.spacesPlus = exports.spaces = void 0;
const map_1 = require("./map");
const opt_1 = require("./opt");
const regex_1 = require("./regex");
const seq_1 = require("./seq");
const str_1 = require("./str");
const utilities_1 = require("./utilities");
/** Parses 0 or more spaces
 */
exports.spaces = regex_1.regex(/ */, 'spaces');
/** Parses 1 or more spaces
 */
exports.spacesPlus = regex_1.regex(/ +/, 'spaces');
/** Parses 0 or more whitespace characters
 */
exports.wspaces = opt_1.opt(regex_1.regex(/(?:\s|\t|\n|\r)+/, 'whitespace characters'));
/** Parses a boolean (true or false) and returns a string
 */
exports.bool = regex_1.regex(/true|false/, 'boolean');
/** Parses a boolean (true or false) and returns a boolean
 */
exports.boolP = map_1.map(exports.bool, val => val === 'true');
/** Parses an integer and returns a string
 */
exports.int = regex_1.regex(/\d+/, 'integer');
/** Parses an integer and returns a number
 */
exports.intP = map_1.map(exports.int, seq => parseInt(seq, 10));
/** Parses a standard real number (X.X) and returns a string
 */
exports.real = utilities_1.expect(map_1.map(seq_1.seq(exports.int, str_1.str('.'), exports.int), ([intPart, , decimalPart]) => `${intPart}.${decimalPart}`), 'real');
/** Parses a standard real number (X.X) and returns a number
 */
exports.realP = map_1.map(exports.real, (seq) => parseFloat(seq));
